#ifndef LOG2_CONSTANT_H
#define LOG2_CONSTANT_H

#include "integer.h"

/* log2_constant<1> = 0
 * log2_constant<2> = 1
 * log2_constant<4> = 2
 * log2_constant<8> = 3
 * log2_constant<15> = 3
 * log2_constant<16> = 4
 */
template <uintmax_t x>
struct log2_constant {
  static const int value = log2_constant<x/2>::value + 1;
};

template <>
struct log2_constant<1> {
  static const int value = 0;
};

template <>
struct log2_constant<0> {
  // will produce a compile error if someone tries to access 'value'
};

#endif
