#ifndef PARITY_CONSTANT_H
#define PARITY_CONSTANT_H

#include "integer.h"

/* Given 2^n input bits [ x0 x1 x2 x3 x4 ... ]
 * Compute output bits  [ y0 y1 y2 y3 y4 ... ]
 * Where yi = x0 XOR x1 XOR ... XOR xi
 */
template <int n, uintmax_t x>
struct parity_constant {
  protected:
    typedef parity_constant<n-1, x> base;
  public:
    static const uintmax_t value = base::value ^ (base::value << (1 << n));
};

/* Base case */
template <uintmax_t x>
struct parity_constant<-1, x> {
  static const uintmax_t value = x;
};

#endif
