#ifndef ALTERA_SLD_HUB_H
#define ALTERA_SLD_HUB_H

#include "common/bus.h"

#include <queue>
#include <vector>

class AlteraSldHub : public Bus {
  public:
    AlteraSldHub(Interconnect* ic);
    
    void recv(RecvQueue::const_iterator i, RecvQueue::const_iterator end);
    SendQueue::const_iterator send(SendQueue::const_iterator i, SendQueue::const_iterator end);
  
    SlavePort& VDR_write;
    SlavePort& VDR_read_write; // VDR = USER0
    SlavePort& VIR_write;
    SlavePort& VIR_read_write; // VIR = USER1
    
  protected:
    // The IR width variables from the hub
    unsigned int m;
    unsigned int n;
    unsigned int nodes;
    
    void scanW();
    void scanR(RecvQueue::const_iterator& i);
    
    // Commands:
    Bits HUB_INFO();
    Bits VIR_CAPTURE(int dev);
    Bits VIR_WRITE(int dev, const Bits& b);
    Bits VIR_READ(const Bits& b);
};

#endif
