#ifndef BYTE_BLASTER_H
#define BYTE_BLASTER_H

#include "common/component.h"
#include <queue>

class ByteBlaster : public Component {
  public:
    ByteBlaster(Interconnect* ic, bool read_flag);
    
    void init();
    void recv(RecvQueue::const_iterator i, RecvQueue::const_iterator end);
    SendQueue::const_iterator send(SendQueue::const_iterator i, SendQueue::const_iterator end);
    
  public:
    MasterPort& op;
    
    SlavePort& read_byte;
    SlavePort& write_byte;
    
  protected:
    int TMS, TDI, TDO;
    bool read_flag;
    
    std::queue<bool> queue;
};

#endif
