#ifndef DELAY_H
#define DELAY_H

#include "common/component.h"
#include <queue>

/* Write a 64-bit value with nanoseconds delay.
 * Returns: empty bits for each write.
 */
class Delay : public Component {
  public:
    Delay(Interconnect* ic);
    
    void recv(RecvQueue::const_iterator i, RecvQueue::const_iterator end);
    SendQueue::const_iterator send(SendQueue::const_iterator i, SendQueue::const_iterator end);
    
    void execute();
    
    MasterPort& delay;
    SlavePort& effect;
  
  protected:
    std::queue<uint64_t> queue;
};

#endif
