#include "common/compat.h"

#include "echo.h"
#include "pinouts/pinouts.h"

Echo::Echo(Interconnect* ic)
 : Component(ic),
   echo  (*addMasterPort("echo",   shift_pinout)),
   effect(*addSlavePort ("effect", command_pinout))
{
}

SendQueue::const_iterator Echo::send(SendQueue::const_iterator i, SendQueue::const_iterator end) {
  for (; i != end; ++i) {
    if (i->master == &reset) continue;
    
    queue.push(i->bits);
    effect();
  }
  
  return i;
}

void Echo::recv(RecvQueue::const_iterator i, RecvQueue::const_iterator end) {
  for (; i != end; ++i) {
    if (queue.empty())
      throw ProtocolViolation(this, "queueu exhausted in recv");
    
    Bits& bits = queue.front();
    echo(bits);
    queue.pop();
  }
}
