#ifndef END_OF_CHAIN_H
#define END_OF_CHAIN_H

#include "common/component.h"

class EndOfChain : public Component {
  public:
    EndOfChain(Interconnect* ic);
    
    void recv(RecvQueue::const_iterator i, RecvQueue::const_iterator end);
    SendQueue::const_iterator send(SendQueue::const_iterator i, SendQueue::const_iterator end);
    
    struct Effect {
      public:
        MasterPort& port();
        
      protected:
        Masters::iterator it;
      
      friend class EndOfChain;
    };
    
    Effect addEffect();
    void removeEffect(Effect e);
};

inline MasterPort& EndOfChain::Effect::port() { 
  return *it;
}

#endif
