#ifndef FTDI_BYTE_MODE_H
#define FTDI_BYTE_MODE_H

// ftdi includes stdint indirectly and screws up the defines
#include "common/integer.h"
#include "common/component.h"

#include <ftdi.h>
#include <queue>

class FTDI_ByteMode : public Component {
  public:
    FTDI_ByteMode(Interconnect* ic, struct usb_device* dev, int baudrate);
    ~FTDI_ByteMode();
    
    void recv(RecvQueue::const_iterator i, RecvQueue::const_iterator end);
    SendQueue::const_iterator send(SendQueue::const_iterator i, SendQueue::const_iterator end);
    void execute();
    
    MasterPort& write;
    MasterPort& read;
    
    SlavePort& effect;
    
  protected:
    int baudrate;
    struct ftdi_context ftdi;
    
    struct Operation {
      unsigned char* buf;
      unsigned int len;
    };
    typedef std::queue<Operation> Operations;
    Operations toExecute;
    Operations toRecv;
    
    void flush_write(Operation& o);
    void flush_read(unsigned int& len);
};

#endif
