#ifndef GDB_SERIAL_H
#define GDB_SERIAL_H

#include "common/component.h"

class GDB_Serial : public Component {
  public:
    GDB_Serial(Interconnect* ic);
    
    void recv(RecvQueue::const_iterator i, RecvQueue::const_iterator end);
    SendQueue::const_iterator send(SendQueue::const_iterator i, SendQueue::const_iterator end);
    
    MasterPort& uart;
    
    SlavePort& echo;
    SlavePort& packet;
    
  protected:
    int tail;
    std::string buffer;
    
    void runCommand();
};

#endif
