#ifndef JTAG_BITBANG_H
#define JTAG_BITBANG_H

#include <queue>
#include "common/component.h"

class JTAG_BitBang : public Component {
  public:
    JTAG_BitBang(Interconnect* ic);
    
    void recv(RecvQueue::const_iterator i, RecvQueue::const_iterator end);
    SendQueue::const_iterator send(SendQueue::const_iterator i, SendQueue::const_iterator end);
    
  public:
    MasterPort& IR_write;
    MasterPort& IR_read_write;
    MasterPort& DR_write;
    MasterPort& DR_read_write;
    
    SlavePort& JTAG_write;
    SlavePort& JTAG_read_write;
    
  protected:
    void write(int tms, int tdo);
    void read_write(int tms, int tdo);
  
    int TMS, TDI, TDO; // jtag pins
    uint64_t delay; // clock delay
    
    struct Op {
      bool ir;
      int bits;
      
      Op(bool i, int b) : ir(i), bits(b) { }
    };
    typedef std::queue<Op> Queue;
    
    Queue queue;
};

#endif
