#include "common/compat.h"

#include "pinouts/pinouts.h"
#include "lm32-break.h"

LM32Break::LM32Break(Interconnect* ic)
 : LM32Base(ic),
   execute(*addMasterPort("break", command_pinout)) {
}

SendQueue::const_iterator LM32Break::send(SendQueue::const_iterator i, SendQueue::const_iterator end) {
  for (; i != end; ++i) {
    if (i->master == &reset) continue;
    send_command(BREAK);
  }
  return i;
}

void LM32Break::recv(unsigned int status, uint8_t value) {
  throw ProtocolViolation(this, "reboot recv'd");
}
