#include "common/compat.h"

#include "pinouts/pinouts.h"
#include "lm32-reboot.h"

LM32Reboot::LM32Reboot(Interconnect* ic)
 : LM32Base(ic),
   execute(*addMasterPort("reboot", command_pinout)) {
}

SendQueue::const_iterator LM32Reboot::send(SendQueue::const_iterator i, SendQueue::const_iterator end) {
  for (; i != end; ++i) {
    if (i->master == &reset) continue;
    send_command(RESET);
  }
  return i;
}

void LM32Reboot::recv(unsigned int status, uint8_t value) {
  throw ProtocolViolation(this, "reboot recv'd");
}
