#ifndef PHASE_MAP_H
#define PHASE_MAP_H

#include "common/bus.h"

class Map : public Bus {
  public:
    Map(Interconnect* ic, int addrLen, bool recvs);
    
    void recv(RecvQueue::const_iterator i, RecvQueue::const_iterator end);
    SendQueue::const_iterator send(SendQueue::const_iterator i, SendQueue::const_iterator end);
    
    struct Register {
      public:
        MasterPort& port();
      
      protected:
        Masters::iterator it;
      
      friend class Map;
    };
    
    Register addRegister(uint32_t value);
    void removeRegister(Register r);
    
    SlavePort& address;
    SlavePort& data;
  
  protected:
    int addrLen;
    bool recvs;
};

inline MasterPort& Map::Register::port() { return *it; }

#endif
