#ifndef RAWRABBIT_H
#define RAWRABBIT_H

#include "common/component.h"
#include <queue>

class RawRabbit : public Component {
  public:
    RawRabbit(Interconnect* ic, const std::string& device = "/dev/rawrabbit");
    ~RawRabbit();
    
    void recv(RecvQueue::const_iterator i, RecvQueue::const_iterator end);
    SendQueue::const_iterator send(SendQueue::const_iterator i, SendQueue::const_iterator end);
    void execute();
    
  public:
    MasterPort& address;
    MasterPort& read;
    MasterPort& write;
    
    SlavePort& effect;
  
  protected:
    int fd;
    uint32_t currentAddress;
    
    struct Operation {
      uint32_t address;
      uint32_t data;
      bool write;
    };
    
    typedef std::queue<Operation> Operations;
    Operations toExecute;
    Operations toRecv;
};

#endif
